#include "CCapeBadArgument.h"

namespace R2PException{
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadArgument::CCapeBadArgument(HRESULT hr, const std::wstring& desc): CCapeData(hr, desc){
	_position = 0;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadArgument::CCapeBadArgument(IDispatch* pDisp) : CCapeData(pDisp){
	ECapeBadArgument* pECBadArg = NULL;
	HRESULT hres = pDisp->QueryInterface(IID_ECapeBadArgument,(void**)&pECBadArg);
	if (FAILED(hres)){
		_description += L"WARNING: Cannot access ECapeBadArgument error interface from a third CAPE_OPEN component: attributes are undefined.\n";
	}
	else{
		hres = pECBadArg->get_position(&_position);
		if(FAILED(hres))
			_description += L"WARNING: get_position method on ECapeBadArgument has failed. Position attribute is undefined.\n";
	}
	if(pECBadArg) pECBadArg->Release();
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeBadArgument::~CCapeBadArgument(){
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBadArgument::get_position(short& pos){
	pos = _position;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CCapeBadArgument::set_position(short pos){
	_position = pos;
}
} //End namespace R2PException
