// CCapeInvalidOperation.h: interface for the ECapeInvalidOperation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEINVALIDOPERATION_H__)
#define __CCAPEINVALIDOPERATION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeComputation.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: This operation is not valid in the current context</summary> 
	class CCapeInvalidOperation: public CCapeComputation
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeInvalidOperation(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeInvalidOperation object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeInvalidOperation interface</param>
		CCapeInvalidOperation(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeInvalidOperation();

	};
}
#endif // __CCAPEINVALIDOPERATION_H__
