// CCapeLicenceError.h: interface for the ECapeLicenceError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPELICENCEERROR_H__)
#define __CCAPELICENCEERROR_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeData.h"


namespace R2PException{
	/// <summary>Exception handling class: An operation can not be completed because the licence agreement is not respected</summary> 
	class CCapeLicenceError: public CCapeData
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeLicenceError(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeLicenceError object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeLicenceError interface</param>
		CCapeLicenceError(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeLicenceError();

	};
}
#endif // __CCAPELICENCEERROR_H__
