// CCapeNoImpl.h: interface for the ECapeNoImpl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPENOIMPL_H__)
#define __CCAPENOIMPL_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeImplementation.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The operation is "not" implemented even if this operation can be called due to the compatibility with the CO standard. That is to say that the operation exists but it is not supported by the current implementation</summary> 
	class CCapeNoImpl: public CCapeImplementation
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeNoImpl(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeNoImpl object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeNoImpl interface</param>
		CCapeNoImpl(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeNoImpl();

	};
}
#endif // __CCAPENOIMPL_H__
