// CCapeOutOfBounds.h: interface for the ECapeOutOfBounds class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEOUTOFBOUNDS_H__)
#define __CCAPEOUTOFBOUNDS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeBadArgument.h"
#include "CCapeBoundaries.h"
#include "stdafx.h"


namespace R2PException{
	/// <summary>Exception handling class: An argument value is outside of the bounds</summary> 
	class CCapeOutOfBounds: public CCapeBadArgument, public CCapeBoundaries
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeOutOfBounds(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeOutOfBounds object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeOutOfBounds interface</param>
		CCapeOutOfBounds(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeOutOfBounds();
	};
}
#endif // __CCAPEOUTOFBOUNDS_H__
