// CCapeOutOfResources.h: interface for the ECapeOutOfResources class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEOUTOFRESOURCES_H__)
#define __CCAPEOUTOFRESOURCES_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeComputation.h"
#include "CCapeBoundaries.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The physical resources necessary to the execution of the operation are out of limits</summary> 
	class CCapeOutOfResources: public CCapeComputation, public CCapeBoundaries
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeOutOfResources(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeOutOfResources object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeOutOfResources interface</param>
		CCapeOutOfResources(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		virtual ~CCapeOutOfResources();

	};
}
#endif // __CCAPEOUTOFRESOURCES_H__
