// CCapePersistenceSystemError.h: interface for the ECapePersistenceSystemError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEPERSISTENCESYSTEMERROR_H__)
#define __CCAPEPERSISTENCESYSTEMERROR_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapePersistence.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: There is a severe error within the persistence system</summary> 
	class CCapePersistenceSystemError: public CCapePersistence
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapePersistenceSystemError(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapePersistenceSystemError object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapePersistenceSystemError interface</param>
		CCapePersistenceSystemError(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapePersistenceSystemError();

	};
}
#endif // __CCAPEPERSISTENCESYSTEMERROR_H__
