// CCapeTimeOut.h: interface for the ECapeTimeOut class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPETIMEOUT_H__)
#define __CCAPETIMEOUT_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeOutOfResources.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The time-out criterion is reached</summary> 
	class CCapeTimeOut: public CCapeOutOfResources
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeTimeOut(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeTimeOut object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeTimeOut interface</param>
		CCapeTimeOut(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeTimeOut();

	};
}
#endif // __CCAPETIMEOUT_H__
