// CCapeUnknown.h: interface for the ECapeUnknown class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEUNKNOWN_H__)
#define __CCAPEUNKNOWN_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeUser.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The error to be raised when other error(s), specified by the operation, do not suit</summary> 
	class CCapeUnknown: public CCapeUser
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeUnknown(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeUnknown object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeUnknown interface</param>
		CCapeUnknown(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeUnknown();

	};
}
#endif // __CCAPEUNKNOWN_H__
