#if !defined(__CCAPEERROR_H__)
#define __CCAPEERROR_H__

#include "StdAfx.h"
#import "CAPE-OPENv1-1-0.tlb"		raw_interfaces_only, raw_native_types, no_namespace, named_guids
#include <ATLBase.h>
#include <ATLCOM.h>
#include "atlcom.h"

#include <CMyException.h>

class ATL_NO_VTABLE CCapeError:
	public IDispatchImpl<ECapeUser					, &IID_ECapeUser					, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeData					, &IID_ECapeData					, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeRoot					, &IID_ECapeRoot					, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeUnknown				, &IID_ECapeUnknown					, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeInvalidArgument		, &IID_ECapeInvalidArgument			, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeOutOfBounds 			, &IID_ECapeOutOfBounds				, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeBadArgument	 		, &IID_ECapeBadArgument				, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeComputation	 		, &IID_ECapeComputation				, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeBadCOParameter		, &IID_ECapeBadCOParameter			, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeBadInvOrder			, &IID_ECapeBadInvOrder				, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeBoundaries			, &IID_ECapeBoundaries				, &LIBID_CAPEOPEN110>,
	public IDispatchImpl<ECapeFailedInitialisation	, &IID_ECapeFailedInitialisation	, &LIBID_CAPEOPEN110>		
{
public:

	CCapeError() throw(...);
	virtual ~CCapeError() = 0;
	//ECapeUser
	STDMETHOD(get_code)					(/*[out, retval]*/ long* code);
	STDMETHOD(get_description)			(/*[out, retval]*/ BSTR* description);
	STDMETHOD(get_scope)				(/*[out, retval]*/ BSTR* scope);
	STDMETHOD(get_interfaceName)		(/*[out, retval]*/ BSTR* interfaceName);
	STDMETHOD(get_operation)			(/*[out, retval]*/ BSTR* operation);
	STDMETHOD(get_moreInfo)				(/*[out, retval]*/ BSTR* moreInfo);

	//ECapeData				

	//ECapeRoot				
	STDMETHOD(get_name)					(/*[out, retval]*/ BSTR* name);
	
	//ECapeUnknown			
	
	//ECapeInvalidArgument	
	
	//ECapeOutOfBounds

	//ECapeBadArgument
	STDMETHOD(get_position)				(/*[out,retval]*/ short * position);

	//ECapeBadCOParameter
	STDMETHOD(get_parameterName)		(/*[out, retval]*/ BSTR* parametername);
    STDMETHOD(get_parameter)			(/*[out, retval]*/ IDispatch** parameter);

	
	//ECapeBadInvOrder
	STDMETHOD(get_requestedOperation)	(/*[out, retval]*/ BSTR* requestedOperation);

	//ECapeBoundaries
	STDMETHOD(get_LowerBound)			(/*[out, retval]*/ double* LowerBound);
	STDMETHOD(get_UpperBound)			(/*[out, retval]*/ double* UpperBound);
	STDMETHOD(get_value)				(/*[out, retval]*/ double* value);
	STDMETHOD(get_Type)					(/*[out, retval]*/ BSTR* Type);

	//ECapeFailedInitialisation


public:
	R2PException::CMyException* mCOError;
};

#endif