// CCapeImplementation.h: interface for the ECapeImplementation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEIMPLEMENTATION_H__)
#define __CCAPEIMPLEMENTATION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeUser.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: The base class of the errors hierarchy related to the current implementation</summary> 
	class CCapeImplementation: public CCapeUser
	{
	public:
		//// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeImplementation(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeImplementation object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeImplementation interface</param>
		CCapeImplementation(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		virtual ~CCapeImplementation();

	};
}
#endif // __CCAPEIMPLEMENTATION_H__
