// CCapePersistence.h: interface for the ECapePersistence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPEPERSISTENCE_H__)
#define __CCAPEPERSISTENCE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeUser.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class. The base class of the errors hierarchy related to the persistence</summary> 
	class CCapePersistence: public CCapeUser
	{
	public:
		//// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapePersistence(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapePersistence object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapePersistence interface</param>
		CCapePersistence(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		virtual ~CCapePersistence();

	};
}
#endif // __CCAPEPERSISTENCE_H__
