// CCapeSolvingError.h: interface for the ECapeSolvingError class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CCAPESOLVINGERROR_H__)
#define __CCAPESOLVINGERROR_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "CCapeComputation.h"
#include "stdafx.h"

namespace R2PException{
	/// <summary>Exception handling class: A numerical algorithm fails for any reasons</summary> 
	class CCapeSolvingError: public CCapeComputation
	{
	public:
		/// <summary>Constructor</summary>
		/// <param name="hr">legacy error code</param>
		/// <param name="desc">default error description</param>
		CCapeSolvingError(HRESULT hr, const std::wstring& desc = L"");

		/// <summary>Constructor: create a CCapeSolvingError object from a CAPE-OPEN component</summary>
		/// <param name="pDisp">pointer to a CAPE-OPEN component which have to expose ECapeSolvingError interface</param>
		CCapeSolvingError(IDispatch* pDisp);

		/// <summary>Destructor</summary>
		~CCapeSolvingError();

	};
}
#endif // __CCAPESOLVINGERROR_H__
