#include "CWarning.h"

namespace R2PException{
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CWarning::CWarning(){
	_lstWarn = new std::list<CCapeWarning*>;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CWarning::~CWarning(){
	if(_lstWarn){
		for(std::list<CCapeWarning*>::iterator it = _lstWarn->begin(); it != _lstWarn->end(); ++it)
			delete *it;

		delete _lstWarn;
	}
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CWarning::AddWarning(const std::wstring& name, const std::wstring& desc, const std::wstring& interfaceName, const std::wstring& userOperation, HRESULT hr){
	CCapeWarning* pWarn = new CCapeWarning(hr);
	pWarn->set_name(name);
	pWarn->set_description(desc);
	pWarn->set_interfaceName(interfaceName);
	pWarn->set_operation(userOperation);
	_lstWarn->push_back(pWarn);
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CWarning::AddWarning(CMyException& herr){
	CCapeWarning* pWarn = new CCapeWarning;
	std::wstring tmp;
	herr.get_name(tmp);
	pWarn->set_name(tmp);
	herr.get_description(tmp);
	pWarn->set_description(tmp);
	herr.get_interfaceName(tmp);
	pWarn->set_interfaceName(tmp);
	herr.get_operation(tmp);
	pWarn->set_operation(tmp);
	_lstWarn->push_back(pWarn);
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
void CWarning::AddWarning(CCapeWarning* pWarn){
	_lstWarn->push_back(pWarn);
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
CCapeWarning* CWarning::RetrieveOne(){
	if(_lstWarn->begin() == _lstWarn->end())
		return NULL;

	CCapeWarning* pWarn = *(_lstWarn->begin());
	_lstWarn->pop_front();

	return pWarn;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
std::list<CCapeWarning*>* CWarning::RetrieveAll(){
	std::list<CCapeWarning*>* pTemp = _lstWarn;
	_lstWarn = new std::list<CCapeWarning*>;
	return pTemp;
}
/****************************************************************************************************************************
*								
*
****************************************************************************************************************************/ 
size_t CWarning::Count(){
	return _lstWarn->size();
}

}